/*****
 * classe matrice
 * classe gerant les matrices 
 *****/

class matrice
{
 private:
  
  int dimension;

  double** tab;

 public:

  matrice(int d);
  ~matrice(void);
  void putCoord(int r, int c, double v){tab[r][c]=v;}
  double getCoord(int r, int c){return tab[r][c];}
  int getDim(void){return dimension;}

  void affiche(void);
    // Affiche la matrice

  int check_inverse(matrice *B);
    // verifie que le receveur et B sont bien inverses

  void putIdentity();
    // met I dans la matrice

  int noZeroInDiagonal(void);
    // renvoie 1 ssi il n'y a aucun zero sur la diagonale

  int approxZeroInDiagonal(void);
    // renvoie 1 ssi il n'y a aucun chiffre proche du zero
    // sur la diagonale

  double frobeniusDelta(matrice *B);
    // renvoie la norme de Frobenius de Receveur - B

  void putProduct(matrice* A, matrice* B);
    // met dans le receveur le produit AB

  int ludcmp(int *indx,double *d);
  void lubksb(int *indx,double *b);

  int inverse(double *det_man, int *det_exp);
    // Inverse le receveur, quelquesoit la matrice
    // Attention: this = matrice entree / sortie
    // *det_man = mantisse du determinant
    // *det_exp = exposant du determinant
    // -> le determinant vaut det_man*10^{det_exp}
    // renvoie 0 si A est singuliere 

  int inverse_diagonal(double *det_man, int *det_exp);
    // Inverse le receveur, quelquesoit la matrice
    // Attention: this = matrice entree / sortie
    // *det_man = mantisse du determinant
    // *det_exp = exposant du determinant
    // -> le determinant vaut det_man*10^{det_exp}
    // renvoie 0 si A est singuliere 
};
  
void test_inv();
